local function Iceboard(p)
	if p.mo.skin == "freezer"
	and not (p.powers[pw_carry]) then
		p.mo.state = S_PLAY_FLOAT
		local pabloo = P_SpawnMobjFromMobj(p.realmo, P_RandomRange(-10, 10) * FRACUNIT, P_RandomRange(-10, 10) * FRACUNIT, 0, MT_DUST)
		pabloo.momx = P_RandomRange(-4, 4)*FRACUNIT
		pabloo.momy = P_RandomRange(-4, 4)*FRACUNIT
		pabloo.momz = P_RandomRange(0, 4)*FRACUNIT
		pabloo.destscale = 4*FRACUNIT
		if p.mo.momz <= 16*FRACUNIT
			p.mo.momz = p.mo.momz + 2*FRACUNIT
		end
		if p.mo.momz >= 15*FRACUNIT then
			p.mo.state = S_PLAY_PAIN
		end
	end
end

addHook("AbilitySpecial", function(p)
	if p.mo.skin == "freezer"
	and not (p.powers[pw_carry]) then
		p.pflags = $|PF_THOKKED
		if (p.mo.state == S_PLAY_PAIN) then return end
	end
end)

addHook("PlayerThink", function(p)
	if p.mo.skin == "freezer"
		and not (p.powers[pw_carry]) then

		if (p.iceboard == nil) then
			p.iceboard = 0
		end

		if (p.iceboard == 1) then
			if p.pflags & PF_THOKKED then
				p.pflags = $1 & ~PF_THOKKED
			end
			if (P_IsObjectOnGround(p.mo)) then
				p.iceboard = 0
			end
		end

		if (p.pflags & PF_THOKKED) then
			if (p.mo.state == S_PLAY_PAIN) then return end
			if (p.cmd.buttons & BT_JUMP) then
				Iceboard(p)
				p.iceboard = 0
			else
				p.iceboard = 1
				p.mo.state = S_PLAY_PAIN
			end
		end
	end
end)