local function Up(p)
	if p.mo.skin == "king"
	and (p.powers[pw_super] > 0)
	and not (p.powers[pw_carry]) then
		p.mo.state = S_PLAY_SPRING
		if p.mo.momz <= 20*FRACUNIT
			p.mo.momz = p.mo.momz + 2*FRACUNIT
		end
		if p.pflags & PF_SPINNING then
			p.pflags = $1 & ~PF_SPINNING
		end
	return true end
end

local function Down(p)
	if p.mo.skin == "king"
	and (p.powers[pw_super] > 0)
	and not (p.powers[pw_carry])
	and not (p.cmd.buttons & BT_JUMP) then
		p.mo.state = S_PLAY_FALL
		if p.mo.momz >= -20*FRACUNIT
			p.mo.momz = p.mo.momz - 2*FRACUNIT
		end
		if p.pflags & PF_SPINNING then
			p.pflags = $1 & ~PF_SPINNING
		end
	end
end

addHook("JumpSpecial", Up)
addHook("JumpSpinSpecial", Down)

addHook("PlayerThink", function(p)
	if p.mo.skin == "king"
	and (p.powers[pw_super] > 0)
	and not (p.powers[pw_carry]) then
		if not (P_IsObjectOnGround(p.mo)) then
			p.pflags = $ |PF_CANCARRY
		end
	end
end)